/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../../widget/src/mac/nsIDragHelperService.idl
 */

#ifndef __gen_nsIDragHelperService_h__
#define __gen_nsIDragHelperService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIEventSink_h__
#include "nsIEventSink.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIDragHelperService */
#define NS_IDRAGHELPERSERVICE_IID_STR "22ac1757-14c5-45ef-841e-ca6e932b989c"

#define NS_IDRAGHELPERSERVICE_IID \
  {0x22ac1757, 0x14c5, 0x45ef, \
    { 0x84, 0x1e, 0xca, 0x6e, 0x93, 0x2b, 0x98, 0x9c }}

class NS_NO_VTABLE nsIDragHelperService : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IDRAGHELPERSERVICE_IID)

  /**
   * Call when the mouse has entered the rectangle bounding the browser
   * during a drag.
   *
   * @param inDragRef the native DragReference
   * @param inSink the event sink to which the event will be dispatched
   */
  /* void enter (in DragReference inDragRef, in nsIEventSink inSink); */
  NS_IMETHOD Enter(DragReference inDragRef, nsIEventSink *inSink) = 0;

  /**
   * Call when the mouse is inside the rectangle bounding the browser
   * during a drag. The return value indicates if Gecko would accept the
   * contents of the drag if a drop were to happen with the mouse in the
   * current position. This can be used for doing some rudimentary drop
   * feedback.
   *
   * @param inDragRef the native DragReference
   * @param inSink the event sink to which the event will be dispatched
   *
   * @result <code>PR_TRUE</code> if the drag would be accepted by Gecko.
   *
   */
  /* boolean tracking (in DragReference inDragRef, in nsIEventSink inSink); */
  NS_IMETHOD Tracking(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval) = 0;

  /**
   * Call when the mouse has left the rectangle bounding the browser
   * during a drag.
   *
   * @param inDragRef the native DragReference
   * @param inSink the event sink to which the event will be dispatched
   */
  /* void leave (in DragReference inDragRef, in nsIEventSink inSink); */
  NS_IMETHOD Leave(DragReference inDragRef, nsIEventSink *inSink) = 0;

  /**
   * Call when a drop occurs inside the rectangle bounding the browser.
   *
   * @param inDragRef the native DragReference
   * @param inSink the event sink to which the event will be dispatched
   *
   * @result <code>PR_TRUE</code> if the drag was accepted by Gecko.
   */
  /* boolean drop (in DragReference inDragRef, in nsIEventSink inSink); */
  NS_IMETHOD Drop(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIDRAGHELPERSERVICE \
  NS_IMETHOD Enter(DragReference inDragRef, nsIEventSink *inSink); \
  NS_IMETHOD Tracking(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval); \
  NS_IMETHOD Leave(DragReference inDragRef, nsIEventSink *inSink); \
  NS_IMETHOD Drop(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIDRAGHELPERSERVICE(_to) \
  NS_IMETHOD Enter(DragReference inDragRef, nsIEventSink *inSink) { return _to Enter(inDragRef, inSink); } \
  NS_IMETHOD Tracking(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval) { return _to Tracking(inDragRef, inSink, _retval); } \
  NS_IMETHOD Leave(DragReference inDragRef, nsIEventSink *inSink) { return _to Leave(inDragRef, inSink); } \
  NS_IMETHOD Drop(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval) { return _to Drop(inDragRef, inSink, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIDRAGHELPERSERVICE(_to) \
  NS_IMETHOD Enter(DragReference inDragRef, nsIEventSink *inSink) { return !_to ? NS_ERROR_NULL_POINTER : _to->Enter(inDragRef, inSink); } \
  NS_IMETHOD Tracking(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Tracking(inDragRef, inSink, _retval); } \
  NS_IMETHOD Leave(DragReference inDragRef, nsIEventSink *inSink) { return !_to ? NS_ERROR_NULL_POINTER : _to->Leave(inDragRef, inSink); } \
  NS_IMETHOD Drop(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Drop(inDragRef, inSink, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsDragHelperService : public nsIDragHelperService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIDRAGHELPERSERVICE

  nsDragHelperService();

private:
  ~nsDragHelperService();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsDragHelperService, nsIDragHelperService)

nsDragHelperService::nsDragHelperService()
{
  /* member initializers and constructor code */
}

nsDragHelperService::~nsDragHelperService()
{
  /* destructor code */
}

/* void enter (in DragReference inDragRef, in nsIEventSink inSink); */
NS_IMETHODIMP nsDragHelperService::Enter(DragReference inDragRef, nsIEventSink *inSink)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean tracking (in DragReference inDragRef, in nsIEventSink inSink); */
NS_IMETHODIMP nsDragHelperService::Tracking(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void leave (in DragReference inDragRef, in nsIEventSink inSink); */
NS_IMETHODIMP nsDragHelperService::Leave(DragReference inDragRef, nsIEventSink *inSink)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean drop (in DragReference inDragRef, in nsIEventSink inSink); */
NS_IMETHODIMP nsDragHelperService::Drop(DragReference inDragRef, nsIEventSink *inSink, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIDragHelperService_h__ */
