/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../widget/public/nsIEventSink.idl
 */

#ifndef __gen_nsIEventSink_h__
#define __gen_nsIEventSink_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIEventSink */
#define NS_IEVENTSINK_IID_STR "c0d3a7c8-1dd1-11b2-8903-adcd22d004ab"

#define NS_IEVENTSINK_IID \
  {0xc0d3a7c8, 0x1dd1, 0x11b2, \
    { 0x89, 0x03, 0xad, 0xcd, 0x22, 0xd0, 0x04, 0xab }}

/**
 * The nsIEventSink is implemented internally by Gecko as the conduit
 * through which native events travel into Gecko. You obtain an
 * event sink by QI'ing the top-level nsIWidget, usually a window.
 *
 * @status UNDER_REVIEW
 */
class NS_NO_VTABLE nsIEventSink : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IEVENTSINK_IID)

  /**
   * Entry point for native events into Gecko.
   *
   * @return <code>PR_TRUE</code> if event was handled
   *         <code>PR_FALSE</code> if not handled
   *
   * On Mac, <code>anEvent</code> is a native <code>EventRecord*</code>.
   */
  /* boolean dispatchEvent (in voidPtr anEvent); */
  NS_IMETHOD DispatchEvent(void * anEvent, PRBool *_retval) = 0;

  /**
   * Alerts gecko of a drag event. 
   *
   * @param aMessage the message parameter for a Gecko NS_DRAGDROP_EVENT (See nsGUIEvent.h for list).
   * @param aMouseGlobalX x coordinate of mouse, in global coordinates
   * @param aMouseGlobalY y coordinate of mouse, in global coordinates
   * @param aKeyModifiers a native bitfield of which modifier keys are currently pressed
   *
   * @return <code>PR_TRUE</code> if event was handled
   *         <code>PR_FALSE</code> if not handled
   */
  /* boolean dragEvent (in unsigned long aMessage, in short aMouseGlobalX, in short aMouseGlobalY, in unsigned short aKeyModifiers); */
  NS_IMETHOD DragEvent(PRUint32 aMessage, PRInt16 aMouseGlobalX, PRInt16 aMouseGlobalY, PRUint16 aKeyModifiers, PRBool *_retval) = 0;

  /**
   * Tell gecko to scroll, usually in response to a mouse-wheel
   *
   * @param aVertical <code>PR_TRUE</code> if scrolling veritcally, <code>PR_FALSE</code> if horizontal
   * @param aNumLines the number of lines to scroll, positive for down, negative for up
   * @param aMouseLocalX the x coordinate of the mouse in window (local) coordinates
   * @param aMouseLocalY the y coordinate of the mouse in window (local) coordinates
   */
  /* boolean scroll (in boolean aVertical, in short aNumLines, in short aMouseLocalX, in short aMouseLocalY); */
  NS_IMETHOD Scroll(PRBool aVertical, PRInt16 aNumLines, PRInt16 aMouseLocalX, PRInt16 aMouseLocalY, PRBool *_retval) = 0;

  /**
   * Perform any idle processing (handle timers, set the cursor, etc)
   */
  /* void Idle (); */
  NS_IMETHOD Idle(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIEVENTSINK \
  NS_IMETHOD DispatchEvent(void * anEvent, PRBool *_retval); \
  NS_IMETHOD DragEvent(PRUint32 aMessage, PRInt16 aMouseGlobalX, PRInt16 aMouseGlobalY, PRUint16 aKeyModifiers, PRBool *_retval); \
  NS_IMETHOD Scroll(PRBool aVertical, PRInt16 aNumLines, PRInt16 aMouseLocalX, PRInt16 aMouseLocalY, PRBool *_retval); \
  NS_IMETHOD Idle(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIEVENTSINK(_to) \
  NS_IMETHOD DispatchEvent(void * anEvent, PRBool *_retval) { return _to DispatchEvent(anEvent, _retval); } \
  NS_IMETHOD DragEvent(PRUint32 aMessage, PRInt16 aMouseGlobalX, PRInt16 aMouseGlobalY, PRUint16 aKeyModifiers, PRBool *_retval) { return _to DragEvent(aMessage, aMouseGlobalX, aMouseGlobalY, aKeyModifiers, _retval); } \
  NS_IMETHOD Scroll(PRBool aVertical, PRInt16 aNumLines, PRInt16 aMouseLocalX, PRInt16 aMouseLocalY, PRBool *_retval) { return _to Scroll(aVertical, aNumLines, aMouseLocalX, aMouseLocalY, _retval); } \
  NS_IMETHOD Idle(void) { return _to Idle(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIEVENTSINK(_to) \
  NS_IMETHOD DispatchEvent(void * anEvent, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->DispatchEvent(anEvent, _retval); } \
  NS_IMETHOD DragEvent(PRUint32 aMessage, PRInt16 aMouseGlobalX, PRInt16 aMouseGlobalY, PRUint16 aKeyModifiers, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->DragEvent(aMessage, aMouseGlobalX, aMouseGlobalY, aKeyModifiers, _retval); } \
  NS_IMETHOD Scroll(PRBool aVertical, PRInt16 aNumLines, PRInt16 aMouseLocalX, PRInt16 aMouseLocalY, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Scroll(aVertical, aNumLines, aMouseLocalX, aMouseLocalY, _retval); } \
  NS_IMETHOD Idle(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Idle(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsEventSink : public nsIEventSink
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIEVENTSINK

  nsEventSink();

private:
  ~nsEventSink();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsEventSink, nsIEventSink)

nsEventSink::nsEventSink()
{
  /* member initializers and constructor code */
}

nsEventSink::~nsEventSink()
{
  /* destructor code */
}

/* boolean dispatchEvent (in voidPtr anEvent); */
NS_IMETHODIMP nsEventSink::DispatchEvent(void * anEvent, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean dragEvent (in unsigned long aMessage, in short aMouseGlobalX, in short aMouseGlobalY, in unsigned short aKeyModifiers); */
NS_IMETHODIMP nsEventSink::DragEvent(PRUint32 aMessage, PRInt16 aMouseGlobalX, PRInt16 aMouseGlobalY, PRUint16 aKeyModifiers, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean scroll (in boolean aVertical, in short aNumLines, in short aMouseLocalX, in short aMouseLocalY); */
NS_IMETHODIMP nsEventSink::Scroll(PRBool aVertical, PRInt16 aNumLines, PRInt16 aMouseLocalX, PRInt16 aMouseLocalY, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void Idle (); */
NS_IMETHODIMP nsEventSink::Idle()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIEventSink_h__ */
